package fr.geeks.persistence.jdbc.util;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.naming.Reference;
import javax.naming.StringRefAddr;

public class JndiDatasourceCreator {

	/** constants datasource */
	private static final String url = "jdbc:mysql://localhost:3306/des_geeks?autoReconnect=true";
	private static final String username = "root";
	private static final String password = "";
	private static final String jndiName = "dbGeeks";

	public static void create() throws Exception {
		try {
			// initialisation du contexte
			System.setProperty(Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.fscontext.RefFSContextFactory");
			InitialContext context = new InitialContext();

			// cration d'une rfrence sur la DataSource
			Reference reference = new Reference("javax.sql.DataSource", "org.apache.commons.dbcp.BasicDataSourceFactory", null);
			reference.add(new StringRefAddr("driverClassName", "com.mysql.jdbc.Driver"));
			reference.add(new StringRefAddr("url", url));
			reference.add(new StringRefAddr("username", username));
			reference.add(new StringRefAddr("password", password));
			// liaison de la DataSource au contexte
			context.rebind("jdbc/" + jndiName, reference);
		} catch (NamingException ex) {
			ex.printStackTrace();
		}
	}
}